Index: pjproject/trunk/pjsip-apps/src/test-pjsua/mod_call.py
===================================================================
--- pjproject/trunk/pjsip-apps/src/test-pjsua/mod_call.py	(revision 2009)
+++ pjproject/trunk/pjsip-apps/src/test-pjsua/mod_call.py	(revision 2012)
@@ -51,6 +51,20 @@
 	caller.expect(const.STATE_CONFIRMED)
 
+	# Synchronize stdout
+	caller.send("echo 1")
+	caller.expect("echo 1")
+	callee.send("echo 1")
+	callee.expect("echo 1")
+
+	# Test that media is okay (with RFC 2833 DTMF)
+	time.sleep(2)
+	caller.send("#")
+	caller.send("1122")
+	callee.expect(const.RX_DTMF + "1")
+	callee.expect(const.RX_DTMF + "1")
+	callee.expect(const.RX_DTMF + "2")
+	callee.expect(const.RX_DTMF + "2")
+
 	# Hold call
-	time.sleep(2)
 	caller.send("H")
 	caller.expect(const.MEDIA_HOLD)
@@ -63,11 +77,56 @@
 	callee.expect(const.MEDIA_ACTIVE)
 
-	# UPDATE
+	# Synchronize stdout
+	caller.send("echo 1")
+	caller.expect("echo 1")
+	callee.send("echo 1")
+	callee.expect("echo 1")
+
+	# Test that media is okay (with RFC 2833 DTMF)
+	caller.send("#")
+	caller.send("1122")
+	callee.expect(const.RX_DTMF + "1")
+	callee.expect(const.RX_DTMF + "1")
+	callee.expect(const.RX_DTMF + "2")
+	callee.expect(const.RX_DTMF + "2")
+
+	# Synchronize stdout
+	caller.send("echo 1")
+	caller.expect("echo 1")
+	callee.send("echo 1")
+	callee.expect("echo 1")
+
+	# UPDATE (by caller)
+	caller.send("U")
+	caller.expect(const.MEDIA_ACTIVE)
+	callee.expect(const.MEDIA_ACTIVE)
+	
+	# Synchronize stdout
+	caller.send("echo 1")
+	caller.expect("echo 1")
+	callee.send("echo 1")
+	callee.expect("echo 1")
+
+	# Test that media is okay (with RFC 2833 DTMF)
 	time.sleep(2)
+	caller.send("#")
+	caller.send("1122")
+	callee.expect(const.RX_DTMF + "1")
+	callee.expect(const.RX_DTMF + "1")
+	callee.expect(const.RX_DTMF + "2")
+	callee.expect(const.RX_DTMF + "2")
+
+	# UPDATE (by callee)
 	callee.send("U")
 	callee.expect(const.MEDIA_ACTIVE)
 	caller.expect(const.MEDIA_ACTIVE)
 	
-	# Send DTMF
+	# Synchronize stdout
+	caller.send("echo 1")
+	caller.expect("echo 1")
+	callee.send("echo 1")
+	callee.expect("echo 1")
+
+	# Test that media is okay (with RFC 2833 DTMF)
 	time.sleep(2)
 	caller.send("#")
Index: pjproject/trunk/pjsip-apps/src/test-pjsua/scripts-call/150_srtp_1_2.py
===================================================================
--- pjproject/trunk/pjsip-apps/src/test-pjsua/scripts-call/150_srtp_1_2.py	(revision 2012)
+++ pjproject/trunk/pjsip-apps/src/test-pjsua/scripts-call/150_srtp_1_2.py	(revision 2012)
@@ -0,0 +1,10 @@
+# $Id$
+#
+import inc_cfg
+
+# Simple call
+config = inc_cfg.CallConfig(
+		title = "Callee=optional SRTP, caller=mandatory SRTP",
+		callee_cfg = inc_cfg.Config(arg="--null-audio --use-srtp=1 --srtp-secure=0"),
+		caller_cfg = inc_cfg.Config(arg="--null-audio --use-srtp=2 --srtp-secure=0")
+		)
Index: pjproject/trunk/pjsip-apps/src/test-pjsua/scripts-call/150_srtp_2_1.py
===================================================================
--- pjproject/trunk/pjsip-apps/src/test-pjsua/scripts-call/150_srtp_2_1.py	(revision 2012)
+++ pjproject/trunk/pjsip-apps/src/test-pjsua/scripts-call/150_srtp_2_1.py	(revision 2012)
@@ -0,0 +1,10 @@
+# $Id$
+#
+import inc_cfg
+
+# Simple call
+config = inc_cfg.CallConfig(
+		title = "Callee=mandatory SRTP, caller=optional SRTP",
+		callee_cfg = inc_cfg.Config(arg="--null-audio --use-srtp=2 --srtp-secure=0"),
+		caller_cfg = inc_cfg.Config(arg="--null-audio --use-srtp=1 --srtp-secure=0")
+		)
Index: pjproject/trunk/pjsip-apps/src/test-pjsua/scripts-call/150_srtp_2_2.py
===================================================================
--- pjproject/trunk/pjsip-apps/src/test-pjsua/scripts-call/150_srtp_2_2.py	(revision 2012)
+++ pjproject/trunk/pjsip-apps/src/test-pjsua/scripts-call/150_srtp_2_2.py	(revision 2012)
@@ -0,0 +1,10 @@
+# $Id$
+#
+import inc_cfg
+
+# Simple call
+config = inc_cfg.CallConfig(
+		title = "Callee=mandatory SRTP, caller=mandatory SRTP",
+		callee_cfg = inc_cfg.Config(arg="--null-audio --use-srtp=2 --srtp-secure=0"),
+		caller_cfg = inc_cfg.Config(arg="--null-audio --use-srtp=2 --srtp-secure=0")
+		)