Index: pjproject/trunk/pjsip-apps/src/test-pjsua/inc_cfg.py
===================================================================
--- pjproject/trunk/pjsip-apps/src/test-pjsua/inc_cfg.py	(revision 2013)
+++ pjproject/trunk/pjsip-apps/src/test-pjsua/inc_cfg.py	(revision 2017)
@@ -1,3 +1,3 @@
-# $Id$
+# $Id:$
 
 DEFAULT_ECHO = True
Index: pjproject/trunk/pjsip-apps/src/test-pjsua/inc_const.py
===================================================================
--- pjproject/trunk/pjsip-apps/src/test-pjsua/inc_const.py	(revision 2013)
+++ pjproject/trunk/pjsip-apps/src/test-pjsua/inc_const.py	(revision 2017)
@@ -1,3 +1,3 @@
-# $Id$
+# $Id:$
 # Useful constants
 
Index: pjproject/trunk/pjsip-apps/src/test-pjsua/inc_param.py
===================================================================
--- pjproject/trunk/pjsip-apps/src/test-pjsua/inc_param.py	(revision 2013)
+++ pjproject/trunk/pjsip-apps/src/test-pjsua/inc_param.py	(revision 2017)
@@ -1,3 +1,3 @@
-# $Id$
+# $Id:$
 ###########################################
 # pjsua instantiation parameter
Index: pjproject/trunk/pjsip-apps/src/test-pjsua/mod_call.py
===================================================================
--- pjproject/trunk/pjsip-apps/src/test-pjsua/mod_call.py	(revision 2013)
+++ pjproject/trunk/pjsip-apps/src/test-pjsua/mod_call.py	(revision 2017)
@@ -1,3 +1,3 @@
-# $Id$
+# $Id:$
 import time
 import imp
Index: pjproject/trunk/pjsip-apps/src/test-pjsua/mod_run.py
===================================================================
--- pjproject/trunk/pjsip-apps/src/test-pjsua/mod_run.py	(revision 2013)
+++ pjproject/trunk/pjsip-apps/src/test-pjsua/mod_run.py	(revision 2017)
@@ -1,3 +1,3 @@
-# $Id$
+# $Id:$
 import imp
 import sys
Index: pjproject/trunk/pjsip-apps/src/test-pjsua/run.py
===================================================================
--- pjproject/trunk/pjsip-apps/src/test-pjsua/run.py	(revision 2013)
+++ pjproject/trunk/pjsip-apps/src/test-pjsua/run.py	(revision 2017)
@@ -1,3 +1,3 @@
-# $Id$
+# $Id:$
 import sys
 import imp
Index: pjproject/trunk/pjsip-apps/src/test-pjsua/runall.py
===================================================================
--- pjproject/trunk/pjsip-apps/src/test-pjsua/runall.py	(revision 2017)
+++ pjproject/trunk/pjsip-apps/src/test-pjsua/runall.py	(revision 2017)
@@ -0,0 +1,37 @@
+# $Id:$
+import os
+import sys
+
+# Initialize test list
+tests = []
+
+# Excluded tests (because they fail?)
+excluded_tests = [ "svn",
+		   "pyc",
+		   "scripts-call/150_srtp_1_2",
+		   "scripts-call/150_srtp_2_1",
+                   "scripts-call/300_ice_1_1"]
+
+# Add all tests in "scripts-run" directory.
+for f in os.listdir("scripts-run"):
+    tests.append("mod_run.py scripts-run/" + f)
+
+# Add all tests in "scripts-call" directory.
+for f in os.listdir("scripts-call"):
+    tests.append("mod_call.py scripts-call/" + f)
+
+# Filter-out excluded tests
+for pat in excluded_tests:
+    tests = [t for t in tests if t.find(pat)==-1]
+
+# Now run the tests
+for t in tests:
+	cmdline = "python run.py " + t
+	print "Running " + cmdline
+	ret = os.system(cmdline + " > output.log")
+	if ret != 0:
+		print "Test " + t + " failed."
+		print "Please see 'output.log' for the test log."
+		sys.exit(1)
+
+print "All tests completed successfully"
Index: pjproject/trunk/pjsip-apps/src/test-pjsua/scripts-call/100_simplecall.py
===================================================================
--- pjproject/trunk/pjsip-apps/src/test-pjsua/scripts-call/100_simplecall.py	(revision 2013)
+++ pjproject/trunk/pjsip-apps/src/test-pjsua/scripts-call/100_simplecall.py	(revision 2017)
@@ -1,3 +1,3 @@
-# $Id$
+# $Id:$
 #
 import inc_cfg
Index: pjproject/trunk/pjsip-apps/src/test-pjsua/scripts-call/150_srtp_0_1.py
===================================================================
--- pjproject/trunk/pjsip-apps/src/test-pjsua/scripts-call/150_srtp_0_1.py	(revision 2013)
+++ pjproject/trunk/pjsip-apps/src/test-pjsua/scripts-call/150_srtp_0_1.py	(revision 2017)
@@ -1,3 +1,3 @@
-# $Id$
+# $Id:$
 #
 import inc_cfg
Index: pjproject/trunk/pjsip-apps/src/test-pjsua/scripts-call/150_srtp_1_0.py
===================================================================
--- pjproject/trunk/pjsip-apps/src/test-pjsua/scripts-call/150_srtp_1_0.py	(revision 2013)
+++ pjproject/trunk/pjsip-apps/src/test-pjsua/scripts-call/150_srtp_1_0.py	(revision 2017)
@@ -1,3 +1,3 @@
-# $Id$
+# $Id:$
 #
 import inc_cfg
Index: pjproject/trunk/pjsip-apps/src/test-pjsua/scripts-call/150_srtp_1_1.py
===================================================================
--- pjproject/trunk/pjsip-apps/src/test-pjsua/scripts-call/150_srtp_1_1.py	(revision 2013)
+++ pjproject/trunk/pjsip-apps/src/test-pjsua/scripts-call/150_srtp_1_1.py	(revision 2017)
@@ -1,3 +1,3 @@
-# $Id$
+# $Id:$
 #
 import inc_cfg
Index: pjproject/trunk/pjsip-apps/src/test-pjsua/scripts-call/200_tcp.py
===================================================================
--- pjproject/trunk/pjsip-apps/src/test-pjsua/scripts-call/200_tcp.py	(revision 2013)
+++ pjproject/trunk/pjsip-apps/src/test-pjsua/scripts-call/200_tcp.py	(revision 2017)
@@ -1,7 +1,7 @@
-# $Id:$
+# $Id$
 #
 import inc_cfg
 
-# Simple call
+# TCP call
 config = inc_cfg.CallConfig(
 		title = "TCP transport",
Index: pjproject/trunk/pjsip-apps/src/test-pjsua/scripts-call/300_ice_0_1.py
===================================================================
--- pjproject/trunk/pjsip-apps/src/test-pjsua/scripts-call/300_ice_0_1.py	(revision 2017)
+++ pjproject/trunk/pjsip-apps/src/test-pjsua/scripts-call/300_ice_0_1.py	(revision 2017)
@@ -0,0 +1,10 @@
+# $Id:$
+#
+import inc_cfg
+
+# ICE mismatch
+config = inc_cfg.CallConfig(
+		title = "Callee=no ICE, caller=use ICE",
+		callee_cfg = inc_cfg.Config(arg="--null-audio"),
+		caller_cfg = inc_cfg.Config(arg="--null-audio --use-ice")
+		)
Index: pjproject/trunk/pjsip-apps/src/test-pjsua/scripts-call/300_ice_1_0.py
===================================================================
--- pjproject/trunk/pjsip-apps/src/test-pjsua/scripts-call/300_ice_1_0.py	(revision 2017)
+++ pjproject/trunk/pjsip-apps/src/test-pjsua/scripts-call/300_ice_1_0.py	(revision 2017)
@@ -0,0 +1,10 @@
+# $Id:$
+#
+import inc_cfg
+
+# ICE mismatch
+config = inc_cfg.CallConfig(
+		title = "Callee=use ICE, caller=no ICE",
+		callee_cfg = inc_cfg.Config(arg="--null-audio --use-ice"),
+		caller_cfg = inc_cfg.Config(arg="--null-audio")
+		)
Index: pjproject/trunk/pjsip-apps/src/test-pjsua/scripts-call/300_ice_1_1.py
===================================================================
--- pjproject/trunk/pjsip-apps/src/test-pjsua/scripts-call/300_ice_1_1.py	(revision 2017)
+++ pjproject/trunk/pjsip-apps/src/test-pjsua/scripts-call/300_ice_1_1.py	(revision 2017)
@@ -0,0 +1,10 @@
+# $Id:$
+#
+import inc_cfg
+
+# ICE mismatch
+config = inc_cfg.CallConfig(
+		title = "Callee=use ICE, caller=use ICE",
+		callee_cfg = inc_cfg.Config(arg="--null-audio --use-ice"),
+		caller_cfg = inc_cfg.Config(arg="--null-audio --use-ice")
+		)
Index: pjproject/trunk/pjsip-apps/src/test-pjsua/scripts-run/100_simple.py
===================================================================
--- pjproject/trunk/pjsip-apps/src/test-pjsua/scripts-run/100_simple.py	(revision 2013)
+++ pjproject/trunk/pjsip-apps/src/test-pjsua/scripts-run/100_simple.py	(revision 2017)
@@ -1,3 +1,3 @@
-# $Id$
+# $Id:$
 #
 # Just about the simple pjsua command line parameter, which should